Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class FunctionCall

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, SequenceIterable, InstructionInfo, Locator

Direct Known Subclasses:
  IntegratedFunctionCall, JavaExtensionFunctionCall, SystemFunction, UserFunctionCall, XPathFunctionCall

    public abstract class FunctionCall

extends Expression

Abstract superclass for calls to system-defined and user-defined functions

See Also:
  Serialized Form

Field Summary
`protected Expression[]` | `argument` The array of expressions representing the actual parameters to the function call

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, PUSH_SELECTION, staticProperties, WATCH_METHOD`

Constructor Summary
`FunctionCall()`

Method Summary
`PathMap.PathMapNodeSet` | `addExternalFunctionCallToPathMap(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodes)` Add a representation of this expression to a PathMap.
`protected int` | `checkArgumentCount(int min, int max, ExpressionVisitor visitor)` Check number of arguments.
`protected abstract void` | `checkArguments(ExpressionVisitor visitor)` Method supplied by each class of function to check arguments during parsing, when all the argument expressions have been read
`boolean` | `equals(Object o)` Determine whether two expressions are equivalent
`void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`Expression[]` | `getArguments()` Get the expressions supplied as actual arguments to the function
`String` | `getDisplayName()` Get the name of the function for display in messages
`String` | `getExpressionName()` Get a name identifying the kind of expression, in terms meaningful to a user.
`StructuredQName` | `getFunctionName()` Get the qualified of the function being called
`int` | `getNumberOfArguments()` Determine the number of actual arguments supplied in the function call
`int` | `hashCode()` Get hashCode in support of equals() method
`Iterator<Expression>` | `iterateSubExpressions()` Get the immediate subexpressions of this expression
`Expression` | `optimize(ExpressionVisitor visitor, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` | `preEvaluate(ExpressionVisitor visitor)` Pre-evaluate a function at compile time.
`Expression` | `promote(PromotionOffer offer, Expression parent)` Promote this expression if possible
`boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`void` | `setArguments(Expression[] args)` Method called by the expression parser when all arguments have been supplied
`void` | `setFunctionName(StructuredQName name)` Set the name of the function being called
`Expression` | `simplify(ExpressionVisitor visitor)` Simplify the function call.
`protected Expression` | `simplifyArguments(ExpressionVisitor visitor)` Simplify the arguments of the function.
`String` | `toString()` The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath.
`Expression` | `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Type-check the expression.

Methods inherited from class net.sf.saxon.expr.Expression
`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeCardinality, computeDependencies, computeSpecialProperties, computeStaticProperties, copy, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getItemType, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterate, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### argument

    protected Expression[] argument

  The array of expressions representing the actual parameters to the function call

Constructor Detail

### FunctionCall

    public FunctionCall()

Method Detail

### setFunctionName

    public final void setFunctionName(StructuredQName name)

  Set the name of the function being called

  Parameters:
    `name` - the name of the function

### getFunctionName

    public StructuredQName getFunctionName()

  Get the qualified of the function being called

  Returns:
    the qualified name

### getNumberOfArguments

    public final int getNumberOfArguments()

  Determine the number of actual arguments supplied in the function call

  Returns:
    the arity (the number of arguments)

### setArguments

    public void setArguments(Expression[] args)

  Method called by the expression parser when all arguments have been supplied

  Parameters:
    `args` - the expressions contained in the argument list of the function call

### getArguments

    public Expression[] getArguments()

  Get the expressions supplied as actual arguments to the function

  Returns:
    the array of expressions supplied in the argument list of the function call

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Simplify the function call. Default method is to simplify each of the supplied arguments and evaluate the function if all are now known.

  Overrides:
    `simplify` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### simplifyArguments

    protected final Expression simplifyArguments(ExpressionVisitor visitor)
                                          throws XPathException

  Simplify the arguments of the function. Called from the simplify() method of each function.

  Parameters:
    `visitor` - an expression visitor
  Returns:
    the result of simplifying the arguments of the expression
  Throws:
    `XPathException`

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression. This also calls preEvaluate() to evaluate the function if all the arguments are constant; functions that do not require this behavior can override the preEvaluate method.

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### preEvaluate

    public Expression preEvaluate(ExpressionVisitor visitor)
                           throws XPathException

  Pre-evaluate a function at compile time. Functions that do not allow pre-evaluation, or that need access to context information, can override this method.

  Parameters:
    `visitor` - an expression visitor
  Returns:
    the result of the early evaluation, or the original expression, or potentially a simplified expression
  Throws:
    `XPathException`

### promote

    public Expression promote(PromotionOffer offer,
                              Expression parent)
                       throws XPathException

  Promote this expression if possible

  Overrides:
    `promote` in class `Expression`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### checkArguments

    protected abstract void checkArguments(ExpressionVisitor visitor)
                                    throws XPathException

  Method supplied by each class of function to check arguments during parsing, when all the argument expressions have been read

  Parameters:
    `visitor` - the expression visitor
  Throws:
    `XPathException`

### checkArgumentCount

    protected int checkArgumentCount(int min,
                                     int max,
                                     ExpressionVisitor visitor)
                              throws XPathException

  Check number of arguments.
  A convenience routine for use in subclasses.

  Parameters:
    `min` - the minimum number of arguments allowed
    `max` - the maximum number of arguments allowed
    `visitor` - an expression visitor
  Returns:
    the actual number of arguments
  Throws:
    `XPathException` - if the number of arguments is out of range

### iterateSubExpressions

    public Iterator<Expression> iterateSubExpressions()

  Get the immediate subexpressions of this expression

  Overrides:
    `iterateSubExpressions` in class `Expression`
  Returns:
    an iterator containing the sub-expressions of this expression

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Overrides:
    `replaceSubExpression` in class `Expression`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### addExternalFunctionCallToPathMap

    public PathMap.PathMapNodeSet addExternalFunctionCallToPathMap(PathMap pathMap,
                                                                   PathMap.PathMapNodeSet pathMapNodes)

  Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

  The default implementation of this method assumes that an expression does no navigation other than the navigation done by evaluating its subexpressions, and that the subexpressions are evaluated in the same context as the containing expression. The method must be overridden for any expression where these assumptions do not hold. For example, implementations exist for AxisExpression, ParentExpression, and RootExpression (because they perform navigation), and for the doc(), document(), and collection() functions because they create a new navigation root. Implementations also exist for PathExpression and FilterExpression because they have subexpressions that are evaluated in a different context from the calling expression.

  Parameters:
    `pathMap` - the PathMap to which the expression should be added
    `pathMapNodes` - the node in the PathMap representing the focus at the point where this expression is called. Set to null if this expression appears at the top level, in which case the expression, if it is registered in the path map at all, must create a new path map root.
  Returns:
    the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression. For an expression that does navigation, it represents the end of the arc in the path map that describes the navigation route. For other expressions, it is the same as the input pathMapNode.

### getExpressionName

    public final String getExpressionName()

  Get a name identifying the kind of expression, in terms meaningful to a user.

  Overrides:
    `getExpressionName` in class `Expression`
  Returns:
    a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the expression.

### getDisplayName

    public final String getDisplayName()

  Get the name of the function for display in messages

  Returns:
    the name of the function as a lexical QName

### toString

    public String toString()

  The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath. In the case of XSLT instructions, the toString() method gives an abstracted view of the syntax

  Overrides:
    `toString` in class `Expression`
  Returns:
    a representation of the expression as a string

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `out` - the expression presenter used to display the structure

### equals

    public boolean equals(Object o)

  Determine whether two expressions are equivalent

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Get hashCode in support of equals() method

  Overrides:
    `hashCode` in class `Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.